]> git.ipfire.org Git - thirdparty/git.git/blame_incremental - git-filter-branch.sh
Eleventh batch for 2.7
[thirdparty/git.git] / git-filter-branch.sh
... / ...
CommitLineData
1#!/bin/sh
2#
3# Rewrite revision history
4# Copyright (c) Petr Baudis, 2006
5# Minimal changes to "port" it to core-git (c) Johannes Schindelin, 2007
6#
7# Lets you rewrite the revision history of the current branch, creating
8# a new branch. You can specify a number of filters to modify the commits,
9# files and trees.
10
11# The following functions will also be available in the commit filter:
12
13functions=$(cat << \EOF
14warn () {
15 echo "$*" >&2
16}
17
18map()
19{
20 # if it was not rewritten, take the original
21 if test -r "$workdir/../map/$1"
22 then
23 cat "$workdir/../map/$1"
24 else
25 echo "$1"
26 fi
27}
28
29# if you run 'skip_commit "$@"' in a commit filter, it will print
30# the (mapped) parents, effectively skipping the commit.
31
32skip_commit()
33{
34 shift;
35 while [ -n "$1" ];
36 do
37 shift;
38 map "$1";
39 shift;
40 done;
41}
42
43# if you run 'git_commit_non_empty_tree "$@"' in a commit filter,
44# it will skip commits that leave the tree untouched, commit the other.
45git_commit_non_empty_tree()
46{
47 if test $# = 3 && test "$1" = $(git rev-parse "$3^{tree}"); then
48 map "$3"
49 else
50 git commit-tree "$@"
51 fi
52}
53# override die(): this version puts in an extra line break, so that
54# the progress is still visible
55
56die()
57{
58 echo >&2
59 echo "$*" >&2
60 exit 1
61}
62EOF
63)
64
65eval "$functions"
66
67finish_ident() {
68 # Ensure non-empty id name.
69 echo "case \"\$GIT_$1_NAME\" in \"\") GIT_$1_NAME=\"\${GIT_$1_EMAIL%%@*}\" && export GIT_$1_NAME;; esac"
70 # And make sure everything is exported.
71 echo "export GIT_$1_NAME"
72 echo "export GIT_$1_EMAIL"
73 echo "export GIT_$1_DATE"
74}
75
76set_ident () {
77 parse_ident_from_commit author AUTHOR committer COMMITTER
78 finish_ident AUTHOR
79 finish_ident COMMITTER
80}
81
82USAGE="[--env-filter <command>] [--tree-filter <command>]
83 [--index-filter <command>] [--parent-filter <command>]
84 [--msg-filter <command>] [--commit-filter <command>]
85 [--tag-name-filter <command>] [--subdirectory-filter <directory>]
86 [--original <namespace>] [-d <directory>] [-f | --force]
87 [<rev-list options>...]"
88
89OPTIONS_SPEC=
90. git-sh-setup
91
92if [ "$(is_bare_repository)" = false ]; then
93 require_clean_work_tree 'rewrite branches'
94fi
95
96tempdir=.git-rewrite
97filter_env=
98filter_tree=
99filter_index=
100filter_parent=
101filter_msg=cat
102filter_commit=
103filter_tag_name=
104filter_subdir=
105orig_namespace=refs/original/
106force=
107prune_empty=
108remap_to_ancestor=
109while :
110do
111 case "$1" in
112 --)
113 shift
114 break
115 ;;
116 --force|-f)
117 shift
118 force=t
119 continue
120 ;;
121 --remap-to-ancestor)
122 # deprecated ($remap_to_ancestor is set now automatically)
123 shift
124 remap_to_ancestor=t
125 continue
126 ;;
127 --prune-empty)
128 shift
129 prune_empty=t
130 continue
131 ;;
132 -*)
133 ;;
134 *)
135 break;
136 esac
137
138 # all switches take one argument
139 ARG="$1"
140 case "$#" in 1) usage ;; esac
141 shift
142 OPTARG="$1"
143 shift
144
145 case "$ARG" in
146 -d)
147 tempdir="$OPTARG"
148 ;;
149 --env-filter)
150 filter_env="$OPTARG"
151 ;;
152 --tree-filter)
153 filter_tree="$OPTARG"
154 ;;
155 --index-filter)
156 filter_index="$OPTARG"
157 ;;
158 --parent-filter)
159 filter_parent="$OPTARG"
160 ;;
161 --msg-filter)
162 filter_msg="$OPTARG"
163 ;;
164 --commit-filter)
165 filter_commit="$functions; $OPTARG"
166 ;;
167 --tag-name-filter)
168 filter_tag_name="$OPTARG"
169 ;;
170 --subdirectory-filter)
171 filter_subdir="$OPTARG"
172 remap_to_ancestor=t
173 ;;
174 --original)
175 orig_namespace=$(expr "$OPTARG/" : '\(.*[^/]\)/*$')/
176 ;;
177 *)
178 usage
179 ;;
180 esac
181done
182
183case "$prune_empty,$filter_commit" in
184,)
185 filter_commit='git commit-tree "$@"';;
186t,)
187 filter_commit="$functions;"' git_commit_non_empty_tree "$@"';;
188,*)
189 ;;
190*)
191 die "Cannot set --prune-empty and --commit-filter at the same time"
192esac
193
194case "$force" in
195t)
196 rm -rf "$tempdir"
197;;
198'')
199 test -d "$tempdir" &&
200 die "$tempdir already exists, please remove it"
201esac
202orig_dir=$(pwd)
203mkdir -p "$tempdir/t" &&
204tempdir="$(cd "$tempdir"; pwd)" &&
205cd "$tempdir/t" &&
206workdir="$(pwd)" ||
207die ""
208
209# Remove tempdir on exit
210trap 'cd "$orig_dir"; rm -rf "$tempdir"' 0
211
212ORIG_GIT_DIR="$GIT_DIR"
213ORIG_GIT_WORK_TREE="$GIT_WORK_TREE"
214ORIG_GIT_INDEX_FILE="$GIT_INDEX_FILE"
215GIT_WORK_TREE=.
216export GIT_DIR GIT_WORK_TREE
217
218# Make sure refs/original is empty
219git for-each-ref > "$tempdir"/backup-refs || exit
220while read sha1 type name
221do
222 case "$force,$name" in
223 ,$orig_namespace*)
224 die "Cannot create a new backup.
225A previous backup already exists in $orig_namespace
226Force overwriting the backup with -f"
227 ;;
228 t,$orig_namespace*)
229 git update-ref -d "$name" $sha1
230 ;;
231 esac
232done < "$tempdir"/backup-refs
233
234# The refs should be updated if their heads were rewritten
235git rev-parse --no-flags --revs-only --symbolic-full-name \
236 --default HEAD "$@" > "$tempdir"/raw-heads || exit
237sed -e '/^^/d' "$tempdir"/raw-heads >"$tempdir"/heads
238
239test -s "$tempdir"/heads ||
240 die "Which ref do you want to rewrite?"
241
242GIT_INDEX_FILE="$(pwd)/../index"
243export GIT_INDEX_FILE
244
245# map old->new commit ids for rewriting parents
246mkdir ../map || die "Could not create map/ directory"
247
248# we need "--" only if there are no path arguments in $@
249nonrevs=$(git rev-parse --no-revs "$@") || exit
250if test -z "$nonrevs"
251then
252 dashdash=--
253else
254 dashdash=
255 remap_to_ancestor=t
256fi
257
258git rev-parse --revs-only "$@" >../parse
259
260case "$filter_subdir" in
261"")
262 eval set -- "$(git rev-parse --sq --no-revs "$@")"
263 ;;
264*)
265 eval set -- "$(git rev-parse --sq --no-revs "$@" $dashdash \
266 "$filter_subdir")"
267 ;;
268esac
269
270git rev-list --reverse --topo-order --default HEAD \
271 --parents --simplify-merges --stdin "$@" <../parse >../revs ||
272 die "Could not get the commits"
273commits=$(wc -l <../revs | tr -d " ")
274
275test $commits -eq 0 && die "Found nothing to rewrite"
276
277# Rewrite the commits
278report_progress ()
279{
280 if test -n "$progress" &&
281 test $git_filter_branch__commit_count -gt $next_sample_at
282 then
283 count=$git_filter_branch__commit_count
284
285 now=$(date +%s)
286 elapsed=$(($now - $start_timestamp))
287 remaining=$(( ($commits - $count) * $elapsed / $count ))
288 if test $elapsed -gt 0
289 then
290 next_sample_at=$(( ($elapsed + 1) * $count / $elapsed ))
291 else
292 next_sample_at=$(($next_sample_at + 1))
293 fi
294 progress=" ($elapsed seconds passed, remaining $remaining predicted)"
295 fi
296 printf "\rRewrite $commit ($count/$commits)$progress "
297}
298
299git_filter_branch__commit_count=0
300
301progress= start_timestamp=
302if date '+%s' 2>/dev/null | grep -q '^[0-9][0-9]*$'
303then
304 next_sample_at=0
305 progress="dummy to ensure this is not empty"
306 start_timestamp=$(date '+%s')
307fi
308
309while read commit parents; do
310 git_filter_branch__commit_count=$(($git_filter_branch__commit_count+1))
311
312 report_progress
313
314 case "$filter_subdir" in
315 "")
316 GIT_ALLOW_NULL_SHA1=1 git read-tree -i -m $commit
317 ;;
318 *)
319 # The commit may not have the subdirectory at all
320 err=$(GIT_ALLOW_NULL_SHA1=1 \
321 git read-tree -i -m $commit:"$filter_subdir" 2>&1) || {
322 if ! git rev-parse -q --verify $commit:"$filter_subdir"
323 then
324 rm -f "$GIT_INDEX_FILE"
325 else
326 echo >&2 "$err"
327 false
328 fi
329 }
330 esac || die "Could not initialize the index"
331
332 GIT_COMMIT=$commit
333 export GIT_COMMIT
334 git cat-file commit "$commit" >../commit ||
335 die "Cannot read commit $commit"
336
337 eval "$(set_ident <../commit)" ||
338 die "setting author/committer failed for commit $commit"
339 eval "$filter_env" < /dev/null ||
340 die "env filter failed: $filter_env"
341
342 if [ "$filter_tree" ]; then
343 git checkout-index -f -u -a ||
344 die "Could not checkout the index"
345 # files that $commit removed are now still in the working tree;
346 # remove them, else they would be added again
347 git clean -d -q -f -x
348 eval "$filter_tree" < /dev/null ||
349 die "tree filter failed: $filter_tree"
350
351 (
352 git diff-index -r --name-only --ignore-submodules $commit &&
353 git ls-files --others
354 ) > "$tempdir"/tree-state || exit
355 git update-index --add --replace --remove --stdin \
356 < "$tempdir"/tree-state || exit
357 fi
358
359 eval "$filter_index" < /dev/null ||
360 die "index filter failed: $filter_index"
361
362 parentstr=
363 for parent in $parents; do
364 for reparent in $(map "$parent"); do
365 case "$parentstr " in
366 *" -p $reparent "*)
367 ;;
368 *)
369 parentstr="$parentstr -p $reparent"
370 ;;
371 esac
372 done
373 done
374 if [ "$filter_parent" ]; then
375 parentstr="$(echo "$parentstr" | eval "$filter_parent")" ||
376 die "parent filter failed: $filter_parent"
377 fi
378
379 {
380 while IFS='' read -r header_line && test -n "$header_line"
381 do
382 # skip header lines...
383 :;
384 done
385 # and output the actual commit message
386 cat
387 } <../commit |
388 eval "$filter_msg" > ../message ||
389 die "msg filter failed: $filter_msg"
390 workdir=$workdir @SHELL_PATH@ -c "$filter_commit" "git commit-tree" \
391 $(git write-tree) $parentstr < ../message > ../map/$commit ||
392 die "could not write rewritten commit"
393done <../revs
394
395# If we are filtering for paths, as in the case of a subdirectory
396# filter, it is possible that a specified head is not in the set of
397# rewritten commits, because it was pruned by the revision walker.
398# Ancestor remapping fixes this by mapping these heads to the unique
399# nearest ancestor that survived the pruning.
400
401if test "$remap_to_ancestor" = t
402then
403 while read ref
404 do
405 sha1=$(git rev-parse "$ref"^0)
406 test -f "$workdir"/../map/$sha1 && continue
407 ancestor=$(git rev-list --simplify-merges -1 "$ref" "$@")
408 test "$ancestor" && echo $(map $ancestor) >> "$workdir"/../map/$sha1
409 done < "$tempdir"/heads
410fi
411
412# Finally update the refs
413
414_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
415_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
416echo
417while read ref
418do
419 # avoid rewriting a ref twice
420 test -f "$orig_namespace$ref" && continue
421
422 sha1=$(git rev-parse "$ref"^0)
423 rewritten=$(map $sha1)
424
425 test $sha1 = "$rewritten" &&
426 warn "WARNING: Ref '$ref' is unchanged" &&
427 continue
428
429 case "$rewritten" in
430 '')
431 echo "Ref '$ref' was deleted"
432 git update-ref -m "filter-branch: delete" -d "$ref" $sha1 ||
433 die "Could not delete $ref"
434 ;;
435 $_x40)
436 echo "Ref '$ref' was rewritten"
437 if ! git update-ref -m "filter-branch: rewrite" \
438 "$ref" $rewritten $sha1 2>/dev/null; then
439 if test $(git cat-file -t "$ref") = tag; then
440 if test -z "$filter_tag_name"; then
441 warn "WARNING: You said to rewrite tagged commits, but not the corresponding tag."
442 warn "WARNING: Perhaps use '--tag-name-filter cat' to rewrite the tag."
443 fi
444 else
445 die "Could not rewrite $ref"
446 fi
447 fi
448 ;;
449 *)
450 # NEEDSWORK: possibly add -Werror, making this an error
451 warn "WARNING: '$ref' was rewritten into multiple commits:"
452 warn "$rewritten"
453 warn "WARNING: Ref '$ref' points to the first one now."
454 rewritten=$(echo "$rewritten" | head -n 1)
455 git update-ref -m "filter-branch: rewrite to first" \
456 "$ref" $rewritten $sha1 ||
457 die "Could not rewrite $ref"
458 ;;
459 esac
460 git update-ref -m "filter-branch: backup" "$orig_namespace$ref" $sha1 ||
461 exit
462done < "$tempdir"/heads
463
464# TODO: This should possibly go, with the semantics that all positive given
465# refs are updated, and their original heads stored in refs/original/
466# Filter tags
467
468if [ "$filter_tag_name" ]; then
469 git for-each-ref --format='%(objectname) %(objecttype) %(refname)' refs/tags |
470 while read sha1 type ref; do
471 ref="${ref#refs/tags/}"
472 # XXX: Rewrite tagged trees as well?
473 if [ "$type" != "commit" -a "$type" != "tag" ]; then
474 continue;
475 fi
476
477 if [ "$type" = "tag" ]; then
478 # Dereference to a commit
479 sha1t="$sha1"
480 sha1="$(git rev-parse -q "$sha1"^{commit})" || continue
481 fi
482
483 [ -f "../map/$sha1" ] || continue
484 new_sha1="$(cat "../map/$sha1")"
485 GIT_COMMIT="$sha1"
486 export GIT_COMMIT
487 new_ref="$(echo "$ref" | eval "$filter_tag_name")" ||
488 die "tag name filter failed: $filter_tag_name"
489
490 echo "$ref -> $new_ref ($sha1 -> $new_sha1)"
491
492 if [ "$type" = "tag" ]; then
493 new_sha1=$( ( printf 'object %s\ntype commit\ntag %s\n' \
494 "$new_sha1" "$new_ref"
495 git cat-file tag "$ref" |
496 sed -n \
497 -e '1,/^$/{
498 /^object /d
499 /^type /d
500 /^tag /d
501 }' \
502 -e '/^-----BEGIN PGP SIGNATURE-----/q' \
503 -e 'p' ) |
504 git mktag) ||
505 die "Could not create new tag object for $ref"
506 if git cat-file tag "$ref" | \
507 sane_grep '^-----BEGIN PGP SIGNATURE-----' >/dev/null 2>&1
508 then
509 warn "gpg signature stripped from tag object $sha1t"
510 fi
511 fi
512
513 git update-ref "refs/tags/$new_ref" "$new_sha1" ||
514 die "Could not write tag $new_ref"
515 done
516fi
517
518cd "$orig_dir"
519rm -rf "$tempdir"
520
521trap - 0
522
523unset GIT_DIR GIT_WORK_TREE GIT_INDEX_FILE
524test -z "$ORIG_GIT_DIR" || {
525 GIT_DIR="$ORIG_GIT_DIR" && export GIT_DIR
526}
527test -z "$ORIG_GIT_WORK_TREE" || {
528 GIT_WORK_TREE="$ORIG_GIT_WORK_TREE" &&
529 export GIT_WORK_TREE
530}
531test -z "$ORIG_GIT_INDEX_FILE" || {
532 GIT_INDEX_FILE="$ORIG_GIT_INDEX_FILE" &&
533 export GIT_INDEX_FILE
534}
535
536if [ "$(is_bare_repository)" = false ]; then
537 git read-tree -u -m HEAD || exit
538fi
539
540exit 0